;+
;Function: THM_FBK_DECOMPRESS
;
;Purpose:  Decompresses DFB FBK spectral data.
;Arguements:
;	DATA, any BYTE data type (scalar or array), 8-bit compressed FBK band-pass amplitude estimates.
;keywords:
;   VERBOSE.
;Example:
;   result = thm_fbk_compress( data)
;
;Notes:
;	-- none.
;
; $LastChangedBy: kenb-mac $
; $LastChangedDate: 2007-07-03 09:10:02 -0700 (Tue, 03 Jul 2007) $
; $LastChangedRevision: 987 $
; $URL $
;-
function thm_fbk_decompress, data, verbose=verbose

thm_init

; vectorized 8->19-bit decompression code.
; Chors Cully, 14 April 2007.
   x=ulong(data)

   ;--- separate xxxx and yyyy ---
   n = x/16
   y = x and 15

   ;--- decompress ---
   z = ulonarr(n_elements(x))
   indx = where(n eq 0, count, complement=indx2, ncomplement=count2)
   if (count gt 0)  then z[indx]=ulong(y[indx])
   if (count2 gt 0) then $
     z[indx2]=(y[indx2]+16)*2UL^(n[indx2]-1)
return, float(z)
end
